Main Page Class Hierarchy Alphabetical List Compound List File List Compound Members File Members Related Pages

# vtkRungeKutta45 Class Reference

`#include <vtkRungeKutta45.h>`

Inheritance diagram for vtkRungeKutta45:

[legend]
Collaboration diagram for vtkRungeKutta45:

[legend]
List of all members.

## Detailed Description

Integrate an initial value problem using 5th.

Date:
  2002/11/06 20:10:00

Revision:
  1.3

order Runge-Kutta method with adaptive stepsize control.

This is a concrete sub-class of vtkInitialValueProblemSolver. It uses a 5th order Runge-Kutta method with stepsize control to obtain the values of a set of functions at the next time step. The stepsize is adjusted by calculating an estimated error using an embedded 4th order Runge-Kutta formula: Press, W. H. et al., 1992, Numerical Recipes in Fortran, Second Edition, Cambridge University Press Cash, J.R. and Karp, A.H. 1990, ACM Transactions on Mathematical Software, vol 16, pp 201-222

See also:
  vtkInitialValueProblemSolver vtkRungeKutta4 vtkRungeKutta2 vtkFunctionSet

Created by:
  - Geveci, Berk

CVS contributions (if > 5%):
  - Geveci, Berk (82%)
  - Cedilnik, Andy (17%)

CVS logs (CVSweb):
  - .`cxx` (`/Common/vtkRungeKutta45.cxx)`
  - .`h` (`/Common/vtkRungeKutta45.h)`

Tests:
  vtkRungeKutta45 (Tests)

Definition at line 57 of file vtkRungeKutta45.h.

## Public Types
typedef vtkInitialValueProblemSolver | Superclass
## Public Methods
virtual const char * | GetClassName ()
virtual int | IsA (const char *type)
virtual int | ComputeNextStep (float *xprev, float *xnext, float t, float &delT, float maxError, float &error)
virtual int | ComputeNextStep (float *xprev, float *dxprev, float *xnext, float t, float &delT, float maxError, float &error)
virtual int | ComputeNextStep (float *xprev, float *xnext, float t, float &delT, float &delTActual, float minStep, float maxStep, float maxError, float &error)
virtual int | ComputeNextStep (float *xprev, float *dxprev, float *xnext, float t, float &delT, float &delTActual, float minStep, float maxStep, float maxError, float &error)
## Static Public Methods
int | IsTypeOf (const char *type)
vtkRungeKutta45 * | SafeDownCast (vtkObject *o)
vtkRungeKutta45 * | New ()
## Protected Methods
| vtkRungeKutta45 ()
| ~vtkRungeKutta45 ()
virtual void | Initialize ()
int | ComputeAStep (float *xprev, float *dxprev, float *xnext, float t, float &delT, float &error)
## Protected Attributes
float * | NextDerivs [6]
## Static Protected Attributes
double | A [5]
double | B [5][5]
double | C [6]
double | DC [6]

## Member Typedef Documentation

typedef vtkInitialValueProblemSolver vtkRungeKutta45::Superclass

| Reimplemented from vtkInitialValueProblemSolver. Definition at line 60 of file vtkRungeKutta45.h.

## Constructor & Destructor Documentation

vtkRungeKutta45::vtkRungeKutta45 | ( |  | ) | `[protected]`

vtkRungeKutta45::~vtkRungeKutta45 | ( |  | ) | `[protected]`

## Member Function Documentation

virtual const char* vtkRungeKutta45::GetClassName | ( |  | ) | `[virtual]`

| Reimplemented from vtkInitialValueProblemSolver.

int vtkRungeKutta45::IsTypeOf | ( | const char * | type | ) | `[static]`

| Return 1 if this class type is the same type of (or a subclass of) the named class. Returns 0 otherwise. This method works in combination with vtkTypeRevisionMacro found in vtkSetGet.h. Reimplemented from vtkInitialValueProblemSolver.

virtual int vtkRungeKutta45::IsA | ( | const char * | type | ) | `[virtual]`

| Return 1 if this class is the same type of (or a subclass of) the named class. Returns 0 otherwise. This method works in combination with vtkTypeRevisionMacro found in vtkSetGet.h. Reimplemented from vtkInitialValueProblemSolver.

vtkRungeKutta45* vtkRungeKutta45::SafeDownCast | ( | vtkObject * | o | ) | `[static]`

| Reimplemented from vtkInitialValueProblemSolver.

vtkRungeKutta45* vtkRungeKutta45::New | ( |  | ) | `[static]`

| Construct a vtkRungeKutta45 with no initial FunctionSet. Reimplemented from vtkObject.

virtual int vtkRungeKutta45::ComputeNextStep | ( | float * | xprev,
|  | float * | xnext,
|  | float | t,
|  | float & | delT,
|  | float | maxError,
|  | float & | error
| ) | `[inline, virtual]`

| Given initial values, xprev , initial time, t and a requested time interval, delT calculate values of x at t+delTActual (xnext). Possibly delTActual != delT. This may occur because this solver supports adaptive stepsize control. It tries to change to stepsize such that the (estimated) error of the integration is less than maxError. The solver will not set the stepsize smaller than minStep or larger than maxStep (note that maxStep and minStep should both be positive, whereas delT can be negative). Also note that delT is an in/out argument. vtkRungeKutta45 will modify delT to reflect the best (estimated) size for the next integration step. An estimated value for the error is returned (by reference) in error. This is the norm of the error vector if there are more than one function to be integrated. This method returns an error code representing the nature of the failure: OutOfDomain = 1, NotInitialized = 2, UnexpectedValue = 3 Reimplemented from vtkInitialValueProblemSolver. Definition at line 81 of file vtkRungeKutta45.h. References vtkInitialValueProblemSolver::ComputeNextStep().

virtual int vtkRungeKutta45::ComputeNextStep | ( | float * | xprev,
|  | float * | dxprev,
|  | float * | xnext,
|  | float | t,
|  | float & | delT,
|  | float | maxError,
|  | float & | error
| ) | `[inline, virtual]`

| Given initial values, xprev , initial time, t and a requested time interval, delT calculate values of x at t+delTActual (xnext). Possibly delTActual != delT. This may occur because this solver supports adaptive stepsize control. It tries to change to stepsize such that the (estimated) error of the integration is less than maxError. The solver will not set the stepsize smaller than minStep or larger than maxStep (note that maxStep and minStep should both be positive, whereas delT can be negative). Also note that delT is an in/out argument. vtkRungeKutta45 will modify delT to reflect the best (estimated) size for the next integration step. An estimated value for the error is returned (by reference) in error. This is the norm of the error vector if there are more than one function to be integrated. This method returns an error code representing the nature of the failure: OutOfDomain = 1, NotInitialized = 2, UnexpectedValue = 3 Reimplemented from vtkInitialValueProblemSolver. Definition at line 90 of file vtkRungeKutta45.h. References vtkInitialValueProblemSolver::ComputeNextStep().

virtual int vtkRungeKutta45::ComputeNextStep | ( | float * | xprev,
|  | float * | xnext,
|  | float | t,
|  | float & | delT,
|  | float & | delTActual,
|  | float | minStep,
|  | float | maxStep,
|  | float | maxError,
|  | float & | error
| ) | `[inline, virtual]`

| Given initial values, xprev , initial time, t and a requested time interval, delT calculate values of x at t+delTActual (xnext). Possibly delTActual != delT. This may occur because this solver supports adaptive stepsize control. It tries to change to stepsize such that the (estimated) error of the integration is less than maxError. The solver will not set the stepsize smaller than minStep or larger than maxStep (note that maxStep and minStep should both be positive, whereas delT can be negative). Also note that delT is an in/out argument. vtkRungeKutta45 will modify delT to reflect the best (estimated) size for the next integration step. An estimated value for the error is returned (by reference) in error. This is the norm of the error vector if there are more than one function to be integrated. This method returns an error code representing the nature of the failure: OutOfDomain = 1, NotInitialized = 2, UnexpectedValue = 3 Reimplemented from vtkInitialValueProblemSolver. Definition at line 100 of file vtkRungeKutta45.h. References vtkInitialValueProblemSolver::ComputeNextStep().

virtual int vtkRungeKutta45::ComputeNextStep | ( | float * | xprev,
|  | float * | dxprev,
|  | float * | xnext,
|  | float | t,
|  | float & | delT,
|  | float & | delTActual,
|  | float | minStep,
|  | float | maxStep,
|  | float | maxError,
|  | float & | error
| ) | `[virtual]`

| Given initial values, xprev , initial time, t and a requested time interval, delT calculate values of x at t+delTActual (xnext). Possibly delTActual != delT. This may occur because this solver supports adaptive stepsize control. It tries to change to stepsize such that the (estimated) error of the integration is less than maxError. The solver will not set the stepsize smaller than minStep or larger than maxStep (note that maxStep and minStep should both be positive, whereas delT can be negative). Also note that delT is an in/out argument. vtkRungeKutta45 will modify delT to reflect the best (estimated) size for the next integration step. An estimated value for the error is returned (by reference) in error. This is the norm of the error vector if there are more than one function to be integrated. This method returns an error code representing the nature of the failure: OutOfDomain = 1, NotInitialized = 2, UnexpectedValue = 3 Implements vtkInitialValueProblemSolver.

virtual void vtkRungeKutta45::Initialize | ( |  | ) | `[protected, virtual]`

| Reimplemented from vtkInitialValueProblemSolver.

int vtkRungeKutta45::ComputeAStep | ( | float * | xprev,
|  | float * | dxprev,
|  | float * | xnext,
|  | float | t,
|  | float & | delT,
|  | float & | error
| ) | `[protected]`

## Member Data Documentation

double vtkRungeKutta45::A[5]`[static, protected]`

| Definition at line 121 of file vtkRungeKutta45.h.

double vtkRungeKutta45::B[5][5]`[static, protected]`

| Definition at line 122 of file vtkRungeKutta45.h.

double vtkRungeKutta45::C[6]`[static, protected]`

| Definition at line 123 of file vtkRungeKutta45.h.

double vtkRungeKutta45::DC[6]`[static, protected]`

| Definition at line 124 of file vtkRungeKutta45.h.

float* vtkRungeKutta45::NextDerivs[6]`[protected]`

| Definition at line 126 of file vtkRungeKutta45.h.

The documentation for this class was generated from the following file:

- Common/vtkRungeKutta45.h